# coding=UTF-8
'''
Created on Apr 4, 2010

@author: ivan
'''
from pluginutils.parseutils import BaseScraper
from pluginutils.parseutils import read_page, XML, HTML
import urlparse
import re, traceback, sys
try:
    import xbmc
    _=xbmc.getLocalizedString
except:
    _=lambda x:x
    
ARTISTS_LIST=(_(30110), 'http://www.o2.music.stream.cz/seznam-interpretu', '')    
    
CACHE_URL='http://cdn-dispatcher.stream.cz/?id=%s'
SEARCH_URL='http://www.o2.music.stream.cz/hledej?q=%s'

RE_FLV_ID=re.compile(r'cdnID=(\d+)')
RE_MP4_ID=re.compile(r'hdID=(\d+)')
def scrap_video(url, quality):
    
    doc=read_page(url)
    player=doc.find('div', id='player')
    flv_id=None
    mp4_id=None
    for script in player.findAll('script'):
        text=script.text
        if text and text.find('writeSWF')>-1:
            m=RE_FLV_ID.search(text)
            if m: flv_id=m.group(1)
            m=RE_MP4_ID.search(text)
            if m: mp4_id=m.group(1)
            
            
    if quality and mp4_id:
        id=mp4_id
    else:
        id=flv_id
    res_url=CACHE_URL%id
    main=doc.find('div', 'col_main_b')
    title=main.h1.find('span', 'title').text
    try:
        artist=main.h1.find('span', 'interpreter').text
    except:
        artist=''
    try:    
        info_bar=main.find('div', 'infobar_top')
        year=int(info_bar.find('span', 'year').a.text)
        genre=info_bar.find('span', 'genre').a.text
    except:
        year=0
        genre=''
        
    if artist:
        title='%s: %s' % (artist, title) 
    if year:
        title+= '(%s)' % year   
    additional_info={'Artist':artist, 'Year':year, 'Genre':genre }
    return res_url, title, additional_info

def scrap_artists(url):
    doc=read_page(url)
    items=doc.find('div', 'all_interpreter_list').findAll('a')
    for item in items:
        yield item.string, urlparse.urljoin(url, item['href']), ''

class ScrapSearchResults(BaseScraper):
    def get_items(self):
        return self.doc.find('ul', 'item_list').findAll('li', {'class': re.compile('clip|show')})
        
    def next(self):
        item=self.items.next()
        
        img_src=item.img['src']
        text=item.find('div', 'text')
        title_elem=text.find('a', 'title')
        title=title_elem.text
        url=title_elem['href']
        interpreter=''  
        plot=''  
        if item['class'] and item['class'].find('clip')>-1:
            try:
                interpreter=text.find('a', 'interpreter').text
            except:
                pass
        else:
            paras=text.findAll('p')
            for p in paras:
                content=p.text or p.text.strip()
                if content:
                    plot=content
                    break
                
        if interpreter:
            title= "%s: %s" %(interpreter, title)

            
        #{ "Title": title, "Director": director, "Duration": runtime, "Plot": plot, "Rating": rating, "Genre": genre, "Count": count, "Date": date } )
        additional_info={'Artist':interpreter, 'Plot':plot, 'Plotoutline':plot}
        return title, urlparse.urljoin(self.url, url), img_src, additional_info
    PG_RE=re.compile(r'&p=(\d+)')
    def next_page(self):
        pager=self.doc.find('div', 'pager')
        if not pager:
            return None
        pages=pager.findAll('a')
        if not pages:
            return None
        
        next_pg_elem=pages[-1]
        if not next_pg_elem.text.find(u'»')>-1:
            return None
        next_pg_url=next_pg_elem['href']
        m=self.PG_RE.search(next_pg_url)
        if m:
            next_page=str(int(m.group(1))+1)
        else:
            next_page=None
        
        base_url=self.url.split('?')
        url=base_url[0]+next_pg_url
        
        return next_page, url, None